#include "opencv2/opencv.hpp"

using namespace cv;

int main()
{
    Mat image = imread("waves.jpg", 0);
    imshow("waves", image);
    Mat histogram, result;
    
    Mat imageROI= image(cv::Rect(5, 200, 50, 50)); //um pedaço do mar
    imshow("ROI", imageROI);
    
    int number_bins = 256;
    float range[] = { 0, 255 };
    const float* ranges = { range };
    
    calcHist( &imageROI, 1, 0, Mat(), histogram, 1, &number_bins, NULL);
    normalize( histogram, histogram, 1.0);
    calcBackProject(&image,
            1, //quantidade de canais
            0, //canais usados
            histogram,    // o histograma das ROIS
            result,       // onde fica o resultado
            &ranges,       // 
            255.0,         // fator de escala
            true
    );
    
    imshow("saida", result);
    
    threshold(result, result, 32, 255, THRESH_BINARY);
    imshow("Binarizada", result); cvWaitKey(0);
            
    
    
}

