#include "opencv2/opencv.hpp"

using namespace cv;

int main()
{
    Mat image = imread("waves.jpg");
    imshow("waves", image);
    Mat  result;
    
    Mat imageROI= image(cv::Rect(5, 200, 70, 70)); //um pedaço do mar
    imshow("ROI", imageROI);
    
    
    MatND histogram;
    
    //para histograma e back projection
    int channel_numbers[] = { 0, 1, 2 };    //numero dos canais
    int* number_bins = new int[image.channels()];   
    for (int ch=0; ch < image.channels(); ch++) 
        number_bins[ch] = 10;                   //nivel de quantização de cada canal (color quantization)
    
    
    float ch_range[] = { 0.0, 255.0 };          //variacao de cada canal na imagem original
    const float* channel_ranges[] = { ch_range, ch_range, ch_range };  

    
    //histograma
    //em ND será armazenado os 3 canais ao mesmo tempo
    calcHist( &imageROI, 1, channel_numbers, Mat(), histogram,
           image.channels(), number_bins, channel_ranges );

    normalize( histogram, histogram, 1.0);
    
    calcBackProject(&image,1,channel_numbers,histogram,result,channel_ranges,255.0);

    imshow("saida", result);
    
    threshold(result, result, 32, 255, THRESH_BINARY);
    imshow("Binarizada", result); cvWaitKey(0);
            
    
    
}

