#include "opencv2/opencv.hpp"

using namespace cv;

Mat getHistogramImage(MatND &hist);

int main() {
    
    Mat  gray_image =  imread("lenna.png", CV_8U);
    imshow("Imagem Lena", gray_image); cvWaitKey(0);
    Mat  display_image;
    MatND  histogram;
    
    int number_bins = 256;

    
    calcHist( &gray_image, 1, 0, Mat(), histogram,
                                             1, &number_bins, NULL );


    normalize(histogram,histogram,1.0); 
    display_image = getHistogramImage(histogram);
    imwrite("hist.png", display_image);
    imshow("Histograma da Lena", display_image);cvWaitKey(0);

}

Mat getHistogramImage(MatND &hist){
    
    double maxVal=0;
    double minVal=0;
    cv::minMaxLoc(hist, &minVal, &maxVal, 0, 0);
    
    //cria imagem onde será desenhado o histograma
    Mat histImg(256, 256,
                    CV_8U,cv::Scalar(255));
    
    //determina o maior H como sendo 90% da imagem
    int hpt = static_cast<int>(0.9*256);
    
    //para cada bin em hist, desenha uma linha vertical
    for( int h = 0; h < 256; h++ ) {
       float binVal = hist.at<float>(h);
       int intensity = static_cast<int>(binVal*hpt/maxVal);
       
       //desenha uma linha entre dois pontos
       line(histImg,Point(h,256),Point(h,256-intensity),Scalar::all(0));
    }
  return histImg;
}